 /*
    # ===========================================================================
    # Copyright (C) 2014  Gerhard Hepp
    #
    # This program is free software; you can redistribute it and/or modify it under the terms of
    # the GNU General Public License as published by the Free Software Foundation; either version 2
    # of the License, or (at your option) any later version.
    #
    # This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
    # without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
    # See the GNU General Public License for more details.
    #
    # You should have received a copy of the GNU General Public License along with this program; if
    # not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
    # MA 02110, USA
    # ===========================================================================
*/
 
 .NOLIST
#include <avr/io.h>
.LIST

// ----------------------------------------
//
// Chip select interrupt.
// reset SPI-Logic states 
//
// ----------------------------------------


.extern t2_counter
.extern irc_current_result
.extern  irc_control

.section .text

.global  PCINT2_vect


PCINT2_vect:

	push R17
	
	in 	R17, _SFR_IO_ADDR(SREG)
	push R17
	
	
    ; -------------------------
    ; get timer 2 and store to result intermediate register
    ; get timer ov register and put there too
    ; reset these registers.
    
	lds      R17, TCNT2
	sts      irc_current_result+1,R17
	lds      R17, t2_counter
	sts      irc_current_result+0,R17
	;
	ldi		 R17,0
    sts      TCNT2, R17
    sts      t2_counter, R17
 	;
 	; signal 'got a change'
	;
	lds		 R17,  irc_control
	ori      R17, 1
	sts       irc_control, R17      
    
#if 0
		    ;
		    ; debug code
		    ;
		    ; if (PIND & ( 1 << PIND6 ))
		    ;    PORTB |= ( 1 << PORTB1);
		    ; else
		    ;    PORTB &= ~( 1 << PORTB1);
		    ;
		    sbic	 _SFR_IO_ADDR(PIND), 6
		    rjmp bit_set
		    
		    cbi _SFR_IO_ADDR(PORTB), 1
		    rjmp ret2
		bit_set:
			sbi _SFR_IO_ADDR(PORTB), 1
#endif
    
ret2:
	
	pop R17
	out _SFR_IO_ADDR(SREG), R17
	
	pop R17
    reti
    

