/*
    # ===========================================================================
    # Copyright (C) 2014  Gerhard Hepp
    #
    # This program is free software; you can redistribute it and/or modify it under the terms of
    # the GNU General Public License as published by the Free Software Foundation; either version 2
    # of the License, or (at your option) any later version.
    #
    # This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
    # without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
    # See the GNU General Public License for more details.
    #
    # You should have received a copy of the GNU General Public License along with this program; if
    # not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
    # MA 02110, USA
    # ===========================================================================
*/

 .NOLIST
#include <avr/io.h>
.LIST




.EXTERN t1_m0         ; uint16_t
.EXTERN t1_mN         ; uint16_t
.EXTERN t1_count      ; uint8_t
.EXTERN t1_maxCount   ; uint16_t

.section .text

.global TIMER1_CAPT_vect


TIMER1_CAPT_vect:

	push R17

	in 	R17, _SFR_IO_ADDR(SREG)
	push R17
	push R16

    ; -------------------------
    ; if ( t1_count == 1){
	;    t1_m0 = val;
	; }

    lds      R16, t1_count
	cpi      R16, 1
	brne     not_1
	;
	lds	R16, ICR1+0
    lds	R17, ICR1+1
	sts	t1_m0+1, R17
    sts	t1_m0+0, R16
	;
	ldi   	R16, 2
	sts     t1_count, R16
	rjmp    ret2


not_1:
     ;   if (t1_count == t1_maxCount)
	 ;   {
	 ;   	t1_mN = val;
	 ;   }

	lds		 R17,t1_maxCount
    cp       R16, R17
    breq     is_maxcount
    brlo     lt_maxCount
    rjmp     ret2
    ;
is_maxcount:
    lds	R16, ICR1+0
    lds	R17, ICR1+1
	sts	t1_mN+1, R17
    sts	t1_mN+0, R16

    lds      R16, t1_count  ; restore R16 to t1Count.

lt_maxCount:
	; R16 is t1Count
	inc		R16
	sts		t1_count, R16

ret2:
	pop R16
	pop R17
	out _SFR_IO_ADDR(SREG), R17

	pop R17
    reti


