# -*- coding: utf-8 -*-
    # ===========================================================================
    # Copyright (C) 2014  Gerhard Hepp
    #
    # This program is free software; you can redistribute it and/or modify it under the terms of
    # the GNU General Public License as published by the Free Software Foundation; either version 2
    # of the License, or (at your option) any later version.
    #
    # This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
    # without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
    # See the GNU General Public License for more details.
    #
    # You should have received a copy of the GNU General Public License along with this program; if
    # not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
    # MA 02110, USA
    # ===========================================================================

 
import time
import sys

import peripherie

peri = peripherie.Peripherie()

try:
    program = False
    read = False
    readFuses = False
    writeFuse = False
    writeFuse20 = False
    reset = False
    
    for i in range (1, len (sys.argv)):

        if '-p' == sys.argv[i]:
            program = True
            programName = sys.argv[i + 1]
        if '-r' == sys.argv[i]:
            read = True
        if '-rf' == sys.argv[i]:
            readFuses = True
        if '-wf' == sys.argv[i]:
            writeFuse = True
        #
        # write flags for 20MHz version
        #
        if '-wf20' == sys.argv[i]:
            writeFuse20 = True
        if '-reset' == sys.argv[i]:
            reset = True
    
    if program:
        print("program", programName)
        
        peri.clearCode()
        peri.writeCode(programName)
        
        print("ok")
        
    if read:
        print("read", "out.hex")
    
        peri.readCode('out.hex')
                
        print("ok")

    if readFuses:
        print("read Fuses")
    
        peri.readFuses()
                
        print("ok")
    
    if writeFuse:
        
        if True:
            print("write Fuse, internal OSC 8MHz")
            print("write Fuse", "0b11100010")
       
            peri.writeFuse(0b11100010)
        else:
            print("write Fuse, external OSC 8 MHz")
            print("write Fuse", "0b11100000")
       
            peri.writeFuse(0b11100000)
     
                   
        print("ok")
        
    if writeFuse20:
        
        if True:
            print("write Fuse, external OSC 20 MHz")
            print("write Fuse", "0b11101111")
       
            peri.writeFuse(0b11101111)
                   
        print("ok")
    
    if reset:    
        print("R E S E T")
        peri.rst(True)
        time.sleep(1)
        peri.rst(False)
        time.sleep(1)
        
            

except KeyboardInterrupt :
    print("interrupt")

except:
    
    print ("Unexpected error:", str(sys.exc_info()[0]))
    print("error")
    raise    
