# -*- coding: utf-8 -*-
    # ===========================================================================
    # Copyright (C) 2014  Gerhard Hepp
    #
    # This program is free software; you can redistribute it and/or modify it under the terms of
    # the GNU General Public License as published by the Free Software Foundation; either version 2
    # of the License, or (at your option) any later version.
    #
    # This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
    # without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
    # See the GNU General Public License for more details.
    #
    # You should have received a copy of the GNU General Public License along with this program; if
    # not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
    # MA 02110, USA
    # ===========================================================================
 
import time
import sys

import peripherie

peri = peripherie.Peripherie()

try:
    peri.cpu_led_on()

    r = peri.cpu_set_adc_config(0x01,0x00)

    for _ in range(100):
        v = peri.cpu_get_adc_0()
        value = v[1] * 256 + v[2] 
        print(value)
        time.sleep(0.1)   
    r = peri.cpu_set_adc_config(0x00,0x00)

    peri.cpu_led_off()
    
except KeyboardInterrupt :
    print("interrupt")

except:
    
    print ("Unexpected error:", str(sys.exc_info()[0]))
    print("error")
    raise    
