# -*- coding: utf-8 -*-
    # ===========================================================================
    # Copyright (C) 2014  Gerhard Hepp
    #
    # This program is free software; you can redistribute it and/or modify it under the terms of
    # the GNU General Public License as published by the Free Software Foundation; either version 2
    # of the License, or (at your option) any later version.
    #
    # This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
    # without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
    # See the GNU General Public License for more details.
    #
    # You should have received a copy of the GNU General Public License along with this program; if
    # not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
    # MA 02110, USA
    # ===========================================================================
 
import time
import sys

import peripherie


speed = 1000000

while speed > 5000 and speed < 10000000:
    try:
        
        peri = peripherie.Peripherie(spi_speed = speed)
        time.sleep(0.1)
        peri.cpu_led_on()
        
        r = peri.cpu_get_config()
        
        peri.cpu_led_off()
        peri.cpu_led_on()
        
        v = peri.cpu_get_version()
        
        peri.cpu_led_off()
        
        peri.close()
        
        if r[1] == 0x03 and r[2] == 0x03 and v[1] == 0x93:
            print("r, v = {r0:02x} {r1:02x}, {v1:02x}".format(r0=r[1], r1=r[2], v1=v[1]))
            speed += 50000
        else:
            print("r, v = {r0:02x} {r1:02x}, {v1:02x}".format(r0=r[1], r1=r[2], v1=v[1]))
            print (speed)
            print ("decrease speed")
            speed -= 10000
            break
        print (speed)
            
    except KeyboardInterrupt :
        print("interrupt")
    
    except:
        
        print ("Unexpected error:", str(sys.exc_info()[0]))
        print("error")
        raise    
