# -*- coding: utf-8 -*-
    # ===========================================================================
    # Copyright (C) 2014  Gerhard Hepp
    #
    # This program is free software; you can redistribute it and/or modify it under the terms of
    # the GNU General Public License as published by the Free Software Foundation; either version 2
    # of the License, or (at your option) any later version.
    #
    # This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
    # without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
    # See the GNU General Public License for more details.
    #
    # You should have received a copy of the GNU General Public License along with this program; if
    # not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
    # MA 02110, USA
    # ===========================================================================

import time
import sys

import peripherie

peri = peripherie.Peripherie(spi_speed=120000)

def intValue(version):
    return (version[1]<<24 )+ (version[2]<<16) + (version[3]<<8) + (version[4]<<0)

try:
    
    peri.cpu_led_on()

    peri.cpu_set_counter_config(3, 0)
    time.sleep(1)
    version0 = peri.cpu_get_counter()
    
    time.sleep(3)
    version1 = peri.cpu_get_counter()
    count0 =  intValue(version0)
    count1 =  intValue(version1)
    
    print( "Counter reported from Controller is: {v1:02x} {v2:02x} {v3:02x} {v4:02x} ".format(v1=version0[1], v2=version0[2], v3=version0[3], v4=version0[4]))
    print( "Counter reported from Controller is: {c:d}".format(c=count0))
    freq = (count1-count0)/3
    print()
    print( "Frequency prox {c:f}".format(c=freq) )
    
    peri.cpu_led_off()

except KeyboardInterrupt:
    print("interrupt")
except:
    print ("Unexpected error:", str(sys.exc_info()[0]))
    print("error")
    raise    
