# -*- coding: utf-8 -*-
    # ===========================================================================
    # Copyright (C) 2014  Gerhard Hepp
    #
    # This program is free software; you can redistribute it and/or modify it under the terms of
    # the GNU General Public License as published by the Free Software Foundation; either version 2
    # of the License, or (at your option) any later version.
    #
    # This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
    # without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
    # See the GNU General Public License for more details.
    #
    # You should have received a copy of the GNU General Public License along with this program; if
    # not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
    # MA 02110, USA
    # ===========================================================================

import time
import sys

import peripherie

peri = peripherie.Peripherie(spi_speed=240000)

try:
    #
    # there is an additional feature: just provide some byte of data.
    # the bytes are fixed and allow for check of transfer
    #
    peri.cpu_led_on()

    for _ in range (1):
        version = peri.cpu_get_testdata()
    
    peri.cpu_led_off()

    print( "Testdata reported from Controller is: {v1:02x} {v2:02x} {v3:02x} {v4:02x} {v5:02x} {v6:02x} {v7:02x} ".format(
                                              v1=version[1], v2=version[2], 
                                              v3=version[3], v4=version[4], 
                                              v5=version[5], v6=version[6], 
                                              v7=version[7]))
    
except KeyboardInterrupt :
    print("interrupt")

except:
    print ("Unexpected error:", str(sys.exc_info()[0]))
    print("error")
    raise    
