# -*- coding: utf-8 -*-
    # ===========================================================================
    # Copyright (C) 2014  Gerhard Hepp
    #
    # This program is free software; you can redistribute it and/or modify it under the terms of
    # the GNU General Public License as published by the Free Software Foundation; either version 2
    # of the License, or (at your option) any later version.
    #
    # This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
    # without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
    # See the GNU General Public License for more details.
    #
    # You should have received a copy of the GNU General Public License along with this program; if
    # not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
    # MA 02110, USA
    # ===========================================================================

import sys
import time

import peripherie

peri = peripherie.Peripherie(spi_speed=120000)

period = 10 # 20
try:
    if False:
        peri.program_reset_on()
        time.sleep(0.01)
        peri.program_reset_off()
        time.sleep(3)

    peri.cpu_led_on()
    if period == 10:
        peri.cpu_set_counter_config( 0x30, 0)
    else:
        peri.cpu_set_counter_config( 0x70, 0)
        
    time.sleep(0.1)

    counter0 = peri.cpu_get_timedcounter()
    
    peri.cpu_led_off()

    print( "Counter reported from Controller is: {v1:02x} {v2:02x} ".format(v1=counter0[1], v2=counter0[2] ))

    if period == 10:
        freq = 100 * ( counter0[1] * 256 + counter0[2] )
    else:
        freq = 50 * ( counter0[1] * 256 + counter0[2] )
    
    print( "Frequency prox {c:f}".format(c=freq) )

except KeyboardInterrupt:
    print("interrupt")
except:
    print ("Unexpected error:", str(sys.exc_info()[0]))
    print("error")
    raise    
