# -*- coding: utf-8 -*-
    # ===========================================================================
    # Copyright (C) 2014  Gerhard Hepp
    #
    # This program is free software; you can redistribute it and/or modify it under the terms of
    # the GNU General Public License as published by the Free Software Foundation; either version 2
    # of the License, or (at your option) any later version.
    #
    # This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
    # without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
    # See the GNU General Public License for more details.
    #
    # You should have received a copy of the GNU General Public License along with this program; if
    # not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
    # MA 02110, USA
    # ===========================================================================

import time
import sys

import peripherie

peri = peripherie.Peripherie(spi_speed=240000)

try:
    peri.cpu_led_on()

    peri.cpu_set_counter_config( 0x18 , 0)
    time.sleep(0.5)

    r = peri.cpu_get_timer()
    
    peri.cpu_led_off()
    value = ( r[1] << 8 ) + r[2]
    period = r[3]
    error = r[4]
    
    print( "Timer reported is: {v1:02x} {v2:02x} {v3:02x} {v4:02x} ".format(v1=r[1], v2=r[2], v3=r[3], v4=r[4]))

    print( "Timer reported   : {value:d} {period:d} {error:02x} ".format(value=value, period=period, error=error ))

    f = 8000000.0 *period / value 
    print(" frequency {freq:f}".format(freq=f))

except KeyboardInterrupt:
    print("interrupt")
except:
    print ("Unexpected error:", str(sys.exc_info()[0]))
    print("error")
    raise    
